diff --git a/src/backend/commands/opclasscmds.c b/src/backend/commands/opclasscmds.c
new file mode 100644
index 3375f10..4319dd7
*** a/src/backend/commands/opclasscmds.c
--- b/src/backend/commands/opclasscmds.c
***************
*** 42,47 ****
--- 42,48 ----
  #include "parser/parse_oper.h"
  #include "parser/parse_type.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/fmgroids.h"
  #include "utils/lsyscache.h"
  #include "utils/rel.h"
*************** DefineOpClass(CreateOpClassStmt *stmt)
*** 334,346 ****
  	ListCell   *l;
  	Relation	rel;
  	HeapTuple	tup;
- 	Form_pg_am	pg_am;
  	Datum		values[Natts_pg_opclass];
  	bool		nulls[Natts_pg_opclass];
  	AclResult	aclresult;
  	NameData	opcName;
  	ObjectAddress myself,
  				referenced;
  
  	/* Convert list of names to a name and namespace */
  	namespaceoid = QualifiedNameGetCreationNamespace(stmt->opclassname,
--- 335,348 ----
  	ListCell   *l;
  	Relation	rel;
  	HeapTuple	tup;
  	Datum		values[Natts_pg_opclass];
  	bool		nulls[Natts_pg_opclass];
  	AclResult	aclresult;
  	NameData	opcName;
  	ObjectAddress myself,
  				referenced;
+ 	IndexAmRoutine *amroutine;
+ 	OpClassInfo	opclassinfo;
  
  	/* Convert list of names to a name and namespace */
  	namespaceoid = QualifiedNameGetCreationNamespace(stmt->opclassname,
*************** DefineOpClass(CreateOpClassStmt *stmt)
*** 361,373 ****
  						stmt->amname)));
  
  	amoid = HeapTupleGetOid(tup);
! 	pg_am = (Form_pg_am) GETSTRUCT(tup);
! 	maxOpNumber = pg_am->amstrategies;
  	/* if amstrategies is zero, just enforce that op numbers fit in int16 */
  	if (maxOpNumber <= 0)
  		maxOpNumber = SHRT_MAX;
! 	maxProcNumber = pg_am->amsupport;
! 	amstorage = pg_am->amstorage;
  
  	/* XXX Should we make any privilege check against the AM? */
  
--- 363,377 ----
  						stmt->amname)));
  
  	amoid = HeapTupleGetOid(tup);
! 
! 	amroutine = GetIndexAmRoutineByAmId(amoid);
! 
! 	maxOpNumber = amroutine->amstrategies;
  	/* if amstrategies is zero, just enforce that op numbers fit in int16 */
  	if (maxOpNumber <= 0)
  		maxOpNumber = SHRT_MAX;
! 	maxProcNumber = amroutine->amsupport;
! 	amstorage = amroutine->amstorage;
  
  	/* XXX Should we make any privilege check against the AM? */
  
*************** DefineOpClass(CreateOpClassStmt *stmt)
*** 582,587 ****
--- 586,597 ----
  							stmt->amname)));
  	}
  
+ 	opclassinfo.intype = typeoid;
+ 	opclassinfo.keytype = storageoid;
+ 	opclassinfo.procedures = procedures;
+ 	opclassinfo.operators = operators;
+ 	amroutine->amvalidate(&opclassinfo);
+ 
  	rel = heap_open(OperatorClassRelationId, RowExclusiveLock);
  
  	/*
*************** DefineOpClass(CreateOpClassStmt *stmt)
*** 718,723 ****
--- 728,816 ----
  	return myself;
  }
  
+ /*
+  * Collect opclass information for validation.
+  */
+ static void
+ getOpClassInfo(OpClassInfo *opclassinfo, Oid opclassoid)
+ {
+ 	HeapTuple		classtup;
+ 	Form_pg_opclass	classform;
+ 	Oid				opfamilyoid;
+ 	CatCList	   *catlist;
+ 	int				i;
+ 
+ 	classtup = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclassoid));
+ 
+ 	if (!HeapTupleIsValid(classtup))
+ 		elog(ERROR, "cache lookup failed for operator class %u", opclassoid);
+ 
+ 	classform = (Form_pg_opclass) GETSTRUCT(classtup);
+ 	opclassinfo->intype = classform->opcintype;
+ 	opclassinfo->keytype = classform->opckeytype;
+ 	opclassinfo->amoid = classform->opcmethod;
+ 	opfamilyoid = classform->opcfamily;
+ 
+ 	ReleaseSysCache(classtup);
+ 
+ 	opclassinfo->operators = NIL;
+ 	opclassinfo->procedures = NIL;
+ 
+ 	/* Find operators */
+ 	catlist = SearchSysCacheList1(AMOPSTRATEGY, opfamilyoid);
+ 	for (i = 0; i < catlist->n_members; i++)
+ 	{
+ 		HeapTuple		oprtup = &catlist->members[i]->tuple;
+ 		Form_pg_amop	oprform = (Form_pg_amop) GETSTRUCT(oprtup);
+ 		OpFamilyMember *opmember = (OpFamilyMember *) palloc0(sizeof(OpFamilyMember));
+ 
+ 		opmember->object = oprform->amopopr;
+ 		opmember->number = oprform->amopstrategy;
+ 		opmember->lefttype = oprform->amoplefttype;
+ 		opmember->righttype = oprform->amoprighttype;
+ 		opmember->sortfamily = oprform->amopsortfamily;
+ 
+ 		opclassinfo->operators = lappend(opclassinfo->operators, opmember);
+ 	}
+ 	ReleaseCatCacheList(catlist);
+ 
+ 	/* Find support functions */
+ 	catlist = SearchSysCacheList1(AMPROCNUM, opfamilyoid);
+ 	for (i = 0; i < catlist->n_members; i++)
+ 	{
+ 		HeapTuple		proctup = &catlist->members[i]->tuple;
+ 		Form_pg_amproc	procform = (Form_pg_amproc) GETSTRUCT(proctup);
+ 		OpFamilyMember *procmember = (OpFamilyMember *) palloc0(sizeof(OpFamilyMember));
+ 
+ 		procmember->object = procform->amproc;
+ 		procmember->number = procform->amprocnum;
+ 		procmember->lefttype = procform->amproclefttype;
+ 		procmember->righttype = procform->amprocrighttype;
+ 
+ 		opclassinfo->procedures = lappend(opclassinfo->procedures, procmember);
+ 	}
+ 	ReleaseCatCacheList(catlist);
+ }
+ 
+ /*
+  * Ask access method to validate given opclass.
+  */
+ Datum
+ amvalidate(PG_FUNCTION_ARGS)
+ {
+ 	OpClassInfo			opclassinfo;
+ 	Oid					opclassoid = PG_GETARG_OID(0);
+ 	IndexAmRoutine	   *amroutine;
+ 
+ 	getOpClassInfo(&opclassinfo, opclassoid);
+ 
+ 	amroutine = GetIndexAmRoutineByAmId(opclassinfo.amoid);
+ 
+ 	amroutine->amvalidate(&opclassinfo);
+ 
+ 	PG_RETURN_BOOL(true);
+ }
+ 
  
  /*
   * DefineOpFamily
*************** AlterOpFamily(AlterOpFamilyStmt *stmt)
*** 776,782 ****
  	int			maxOpNumber,	/* amstrategies value */
  				maxProcNumber;	/* amsupport value */
  	HeapTuple	tup;
! 	Form_pg_am	pg_am;
  
  	/* Get necessary info about access method */
  	tup = SearchSysCache1(AMNAME, CStringGetDatum(stmt->amname));
--- 869,875 ----
  	int			maxOpNumber,	/* amstrategies value */
  				maxProcNumber;	/* amsupport value */
  	HeapTuple	tup;
! 	IndexAmRoutine *amroutine;
  
  	/* Get necessary info about access method */
  	tup = SearchSysCache1(AMNAME, CStringGetDatum(stmt->amname));
*************** AlterOpFamily(AlterOpFamilyStmt *stmt)
*** 787,802 ****
  						stmt->amname)));
  
  	amoid = HeapTupleGetOid(tup);
! 	pg_am = (Form_pg_am) GETSTRUCT(tup);
! 	maxOpNumber = pg_am->amstrategies;
  	/* if amstrategies is zero, just enforce that op numbers fit in int16 */
  	if (maxOpNumber <= 0)
  		maxOpNumber = SHRT_MAX;
! 	maxProcNumber = pg_am->amsupport;
  
  	/* XXX Should we make any privilege check against the AM? */
  
- 	ReleaseSysCache(tup);
  
  	/* Look up the opfamily */
  	opfamilyoid = get_opfamily_oid(amoid, stmt->opfamilyname, false);
--- 880,895 ----
  						stmt->amname)));
  
  	amoid = HeapTupleGetOid(tup);
! 	amroutine = GetIndexAmRoutineByAmId(amoid);
! 	ReleaseSysCache(tup);
! 	maxOpNumber = amroutine->amstrategies;
  	/* if amstrategies is zero, just enforce that op numbers fit in int16 */
  	if (maxOpNumber <= 0)
  		maxOpNumber = SHRT_MAX;
! 	maxProcNumber = amroutine->amsupport;
  
  	/* XXX Should we make any privilege check against the AM? */
  
  
  	/* Look up the opfamily */
  	opfamilyoid = get_opfamily_oid(amoid, stmt->opfamilyname, false);
*************** assignOperTypes(OpFamilyMember *member, 
*** 1099,1119 ****
  		 * the family has been created but not yet populated with the required
  		 * operators.)
  		 */
! 		HeapTuple	amtup;
! 		Form_pg_am	pg_am;
  
! 		amtup = SearchSysCache1(AMOID, ObjectIdGetDatum(amoid));
! 		if (amtup == NULL)
! 			elog(ERROR, "cache lookup failed for access method %u", amoid);
! 		pg_am = (Form_pg_am) GETSTRUCT(amtup);
  
! 		if (!pg_am->amcanorderbyop)
  			ereport(ERROR,
  					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
  			errmsg("access method \"%s\" does not support ordering operators",
! 				   NameStr(pg_am->amname))));
! 
! 		ReleaseSysCache(amtup);
  	}
  	else
  	{
--- 1192,1206 ----
  		 * the family has been created but not yet populated with the required
  		 * operators.)
  		 */
! 		IndexAmRoutine *amroutine;
  
! 		amroutine = GetIndexAmRoutineByAmId(amoid);
  
! 		if (!amroutine->amcanorderbyop)
  			ereport(ERROR,
  					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
  			errmsg("access method \"%s\" does not support ordering operators",
! 				   get_am_name(amoid))));
  	}
  	else
  	{
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
new file mode 100644
index 7668c9d..36b6403
*** a/src/backend/commands/tablecmds.c
--- b/src/backend/commands/tablecmds.c
*************** ATExecSetRelOptions(Relation rel, List *
*** 9374,9380 ****
  			(void) view_reloptions(newOptions, true);
  			break;
  		case RELKIND_INDEX:
! 			(void) index_reloptions(rel->rd_am->amoptions, newOptions, true);
  			break;
  		default:
  			ereport(ERROR,
--- 9374,9380 ----
  			(void) view_reloptions(newOptions, true);
  			break;
  		case RELKIND_INDEX:
! 			(void) index_reloptions(rel->amroutine->amoptions, newOptions, true);
  			break;
  		default:
  			ereport(ERROR,
*************** ATExecReplicaIdentity(Relation rel, Repl
*** 10965,10971 ****
  						RelationGetRelationName(indexRel),
  						RelationGetRelationName(rel))));
  	/* The AM must support uniqueness, and the index must in fact be unique. */
! 	if (!indexRel->rd_am->amcanunique || !indexRel->rd_index->indisunique)
  		ereport(ERROR,
  				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
  			 errmsg("cannot use non-unique index \"%s\" as replica identity",
--- 10965,10971 ----
  						RelationGetRelationName(indexRel),
  						RelationGetRelationName(rel))));
  	/* The AM must support uniqueness, and the index must in fact be unique. */
! 	if (!indexRel->amroutine->amcanunique || !indexRel->rd_index->indisunique)
  		ereport(ERROR,
  				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
  			 errmsg("cannot use non-unique index \"%s\" as replica identity",
diff --git a/src/backend/executor/execAmi.c b/src/backend/executor/execAmi.c
new file mode 100644
index 163650c..78695e0
*** a/src/backend/executor/execAmi.c
--- b/src/backend/executor/execAmi.c
***************
*** 12,17 ****
--- 12,18 ----
   */
  #include "postgres.h"
  
+ #include "access/amapi.h"
  #include "access/htup_details.h"
  #include "executor/execdebug.h"
  #include "executor/nodeAgg.h"
*************** IndexSupportsBackwardScan(Oid indexid)
*** 536,541 ****
--- 537,543 ----
  	HeapTuple	ht_am;
  	Form_pg_class idxrelrec;
  	Form_pg_am	amrec;
+ 	IndexAmRoutine *amroutine;
  
  	/* Fetch the pg_class tuple of the index relation */
  	ht_idxrel = SearchSysCache1(RELOID, ObjectIdGetDatum(indexid));
*************** IndexSupportsBackwardScan(Oid indexid)
*** 549,557 ****
  		elog(ERROR, "cache lookup failed for access method %u",
  			 idxrelrec->relam);
  	amrec = (Form_pg_am) GETSTRUCT(ht_am);
  
! 	result = amrec->amcanbackward;
  
  	ReleaseSysCache(ht_idxrel);
  	ReleaseSysCache(ht_am);
  
--- 551,561 ----
  		elog(ERROR, "cache lookup failed for access method %u",
  			 idxrelrec->relam);
  	amrec = (Form_pg_am) GETSTRUCT(ht_am);
+ 	amroutine = GetIndexAmRoutine(amrec->amhandler);
  
! 	result = amroutine->amcanbackward;
  
+ 	pfree(amroutine);
  	ReleaseSysCache(ht_idxrel);
  	ReleaseSysCache(ht_am);
  
diff --git a/src/backend/executor/nodeIndexscan.c b/src/backend/executor/nodeIndexscan.c
new file mode 100644
index c0f14db..2de0579
*** a/src/backend/executor/nodeIndexscan.c
--- b/src/backend/executor/nodeIndexscan.c
*************** ExecIndexBuildScanKeys(PlanState *planst
*** 1436,1442 ****
  
  			Assert(rightop != NULL);
  
! 			if (index->rd_am->amsearcharray)
  			{
  				/* Index AM will handle this like a simple operator */
  				flags |= SK_SEARCHARRAY;
--- 1436,1442 ----
  
  			Assert(rightop != NULL);
  
! 			if (index->amroutine->amsearcharray)
  			{
  				/* Index AM will handle this like a simple operator */
  				flags |= SK_SEARCHARRAY;
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
new file mode 100644
index 1b61fd9..3fa37e2
*** a/src/backend/optimizer/path/costsize.c
--- b/src/backend/optimizer/path/costsize.c
*************** cost_index(IndexPath *path, PlannerInfo 
*** 406,419 ****
  	 * the fraction of main-table tuples we will have to retrieve) and its
  	 * correlation to the main-table tuple order.
  	 */
! 	OidFunctionCall7(index->amcostestimate,
! 					 PointerGetDatum(root),
! 					 PointerGetDatum(path),
! 					 Float8GetDatum(loop_count),
! 					 PointerGetDatum(&indexStartupCost),
! 					 PointerGetDatum(&indexTotalCost),
! 					 PointerGetDatum(&indexSelectivity),
! 					 PointerGetDatum(&indexCorrelation));
  
  	/*
  	 * Save amcostestimate's results for possible use in bitmap scan planning.
--- 406,413 ----
  	 * the fraction of main-table tuples we will have to retrieve) and its
  	 * correlation to the main-table tuple order.
  	 */
! 	index->amroutine->amcostestimate(root, path, loop_count, &indexStartupCost,
! 						  &indexTotalCost, &indexSelectivity, &indexCorrelation);
  
  	/*
  	 * Save amcostestimate's results for possible use in bitmap scan planning.
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
new file mode 100644
index 9442e5f..d3d5d43
*** a/src/backend/optimizer/util/plancat.c
--- b/src/backend/optimizer/util/plancat.c
*************** get_relation_info(PlannerInfo *root, Oid
*** 223,235 ****
  			}
  
  			info->relam = indexRelation->rd_rel->relam;
! 			info->amcostestimate = indexRelation->rd_am->amcostestimate;
! 			info->amcanorderbyop = indexRelation->rd_am->amcanorderbyop;
! 			info->amoptionalkey = indexRelation->rd_am->amoptionalkey;
! 			info->amsearcharray = indexRelation->rd_am->amsearcharray;
! 			info->amsearchnulls = indexRelation->rd_am->amsearchnulls;
! 			info->amhasgettuple = OidIsValid(indexRelation->rd_am->amgettuple);
! 			info->amhasgetbitmap = OidIsValid(indexRelation->rd_am->amgetbitmap);
  
  			/*
  			 * Fetch the ordering information for the index, if any.
--- 223,235 ----
  			}
  
  			info->relam = indexRelation->rd_rel->relam;
! 			info->amroutine = indexRelation->amroutine;
! 			info->amcanorderbyop = indexRelation->amroutine->amcanorderbyop;
! 			info->amoptionalkey = indexRelation->amroutine->amoptionalkey;
! 			info->amsearcharray = indexRelation->amroutine->amsearcharray;
! 			info->amsearchnulls = indexRelation->amroutine->amsearchnulls;
! 			info->amhasgettuple = OidIsValid(indexRelation->amroutine->amgettuple);
! 			info->amhasgetbitmap = OidIsValid(indexRelation->amroutine->amgetbitmap);
  
  			/*
  			 * Fetch the ordering information for the index, if any.
*************** get_relation_info(PlannerInfo *root, Oid
*** 240,246 ****
  				 * If it's a btree index, we can use its opfamily OIDs
  				 * directly as the sort ordering opfamily OIDs.
  				 */
! 				Assert(indexRelation->rd_am->amcanorder);
  
  				info->sortopfamily = info->opfamily;
  				info->reverse_sort = (bool *) palloc(sizeof(bool) * ncolumns);
--- 240,246 ----
  				 * If it's a btree index, we can use its opfamily OIDs
  				 * directly as the sort ordering opfamily OIDs.
  				 */
! 				Assert(indexRelation->amroutine->amcanorder);
  
  				info->sortopfamily = info->opfamily;
  				info->reverse_sort = (bool *) palloc(sizeof(bool) * ncolumns);
*************** get_relation_info(PlannerInfo *root, Oid
*** 254,260 ****
  					info->nulls_first[i] = (opt & INDOPTION_NULLS_FIRST) != 0;
  				}
  			}
! 			else if (indexRelation->rd_am->amcanorder)
  			{
  				/*
  				 * Otherwise, identify the corresponding btree opfamilies by
--- 254,260 ----
  					info->nulls_first[i] = (opt & INDOPTION_NULLS_FIRST) != 0;
  				}
  			}
! 			else if (indexRelation->amroutine->amcanorder)
  			{
  				/*
  				 * Otherwise, identify the corresponding btree opfamilies by
diff --git a/src/backend/parser/parse_utilcmd.c b/src/backend/parser/parse_utilcmd.c
new file mode 100644
index 16d40c7..0031511
*** a/src/backend/parser/parse_utilcmd.c
--- b/src/backend/parser/parse_utilcmd.c
***************
*** 26,31 ****
--- 26,32 ----
  
  #include "postgres.h"
  
+ #include "access/amapi.h"
  #include "access/htup_details.h"
  #include "access/reloptions.h"
  #include "catalog/dependency.h"
*************** generateClonedIndexStmt(CreateStmtContex
*** 1258,1264 ****
  		iparam->nulls_ordering = SORTBY_NULLS_DEFAULT;
  
  		/* Adjust options if necessary */
! 		if (amrec->amcanorder)
  		{
  			/*
  			 * If it supports sort ordering, copy DESC and NULLS opts. Don't
--- 1259,1265 ----
  		iparam->nulls_ordering = SORTBY_NULLS_DEFAULT;
  
  		/* Adjust options if necessary */
! 		if (source_idx->amroutine->amcanorder)
  		{
  			/*
  			 * If it supports sort ordering, copy DESC and NULLS opts. Don't
diff --git a/src/backend/postmaster/autovacuum.c b/src/backend/postmaster/autovacuum.c
new file mode 100644
index 94e748e..63d6f0d
*** a/src/backend/postmaster/autovacuum.c
--- b/src/backend/postmaster/autovacuum.c
*************** extract_autovac_opts(HeapTuple tup, Tupl
*** 2420,2426 ****
  		   ((Form_pg_class) GETSTRUCT(tup))->relkind == RELKIND_MATVIEW ||
  		   ((Form_pg_class) GETSTRUCT(tup))->relkind == RELKIND_TOASTVALUE);
  
! 	relopts = extractRelOptions(tup, pg_class_desc, InvalidOid);
  	if (relopts == NULL)
  		return NULL;
  
--- 2420,2426 ----
  		   ((Form_pg_class) GETSTRUCT(tup))->relkind == RELKIND_MATVIEW ||
  		   ((Form_pg_class) GETSTRUCT(tup))->relkind == RELKIND_TOASTVALUE);
  
! 	relopts = extractRelOptions(tup, pg_class_desc, NULL);
  	if (relopts == NULL)
  		return NULL;
  
diff --git a/src/backend/utils/adt/pseudotypes.c b/src/backend/utils/adt/pseudotypes.c
new file mode 100644
index 5b809aa..bdd451d
*** a/src/backend/utils/adt/pseudotypes.c
--- b/src/backend/utils/adt/pseudotypes.c
*************** tsm_handler_out(PG_FUNCTION_ARGS)
*** 401,406 ****
--- 401,433 ----
  
  
  /*
+  * index_am_handler_in		- input routine for pseudo-type INDEX_AM_HANDLER.
+  */
+ Datum
+ index_am_handler_in(PG_FUNCTION_ARGS)
+ {
+ 	ereport(ERROR,
+ 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 			 errmsg("cannot accept a value of type index_am_handler")));
+ 
+ 	PG_RETURN_VOID();			/* keep compiler quiet */
+ }
+ 
+ /*
+  * index_am_handler_out		- output routine for pseudo-type INDEX_AM_HANDLER.
+  */
+ Datum
+ index_am_handler_out(PG_FUNCTION_ARGS)
+ {
+ 	ereport(ERROR,
+ 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 			 errmsg("cannot display a value of type index_am_handler")));
+ 
+ 	PG_RETURN_VOID();			/* keep compiler quiet */
+ }
+ 
+ 
+ /*
   * internal_in		- input routine for pseudo-type INTERNAL.
   */
  Datum
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
new file mode 100644
index 51391f6..06f122b
*** a/src/backend/utils/adt/ruleutils.c
--- b/src/backend/utils/adt/ruleutils.c
***************
*** 19,24 ****
--- 19,25 ----
  #include <unistd.h>
  #include <fcntl.h>
  
+ #include "access/amapi.h"
  #include "access/htup_details.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
*************** pg_get_indexdef_worker(Oid indexrelid, i
*** 1167,1172 ****
--- 1168,1174 ----
  		if (!attrsOnly && (!colno || colno == keyno + 1))
  		{
  			Oid			indcoll;
+ 			IndexAmRoutine  *amroutine;
  
  			/* Add collation, if not default for column */
  			indcoll = indcollation->values[keyno];
*************** pg_get_indexdef_worker(Oid indexrelid, i
*** 1177,1184 ****
  			/* Add the operator class name, if not default */
  			get_opclass_name(indclass->values[keyno], keycoltype, &buf);
  
  			/* Add options if relevant */
! 			if (amrec->amcanorder)
  			{
  				/* if it supports sort ordering, report DESC and NULLS opts */
  				if (opt & INDOPTION_DESC)
--- 1179,1188 ----
  			/* Add the operator class name, if not default */
  			get_opclass_name(indclass->values[keyno], keycoltype, &buf);
  
+ 			amroutine = GetIndexAmRoutine(amrec->amhandler);
+ 
  			/* Add options if relevant */
! 			if (amroutine->amcanorder)
  			{
  				/* if it supports sort ordering, report DESC and NULLS opts */
  				if (opt & INDOPTION_DESC)
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
new file mode 100644
index 37fad86..9a83e10
*** a/src/backend/utils/adt/selfuncs.c
--- b/src/backend/utils/adt/selfuncs.c
*************** add_predicate_to_quals(IndexOptInfo *ind
*** 6443,6458 ****
  }
  
  
! Datum
! btcostestimate(PG_FUNCTION_ARGS)
  {
- 	PlannerInfo *root = (PlannerInfo *) PG_GETARG_POINTER(0);
- 	IndexPath  *path = (IndexPath *) PG_GETARG_POINTER(1);
- 	double		loop_count = PG_GETARG_FLOAT8(2);
- 	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(3);
- 	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(4);
- 	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(5);
- 	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(6);
  	IndexOptInfo *index = path->indexinfo;
  	List	   *qinfos;
  	GenericCosts costs;
--- 6443,6453 ----
  }
  
  
! void
! btcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
! 			   Cost *indexStartupCost, Cost *indexTotalCost,
! 			   Selectivity *indexSelectivity, double *indexCorrelation)
  {
  	IndexOptInfo *index = path->indexinfo;
  	List	   *qinfos;
  	GenericCosts costs;
*************** btcostestimate(PG_FUNCTION_ARGS)
*** 6741,6760 ****
  	*indexTotalCost = costs.indexTotalCost;
  	*indexSelectivity = costs.indexSelectivity;
  	*indexCorrelation = costs.indexCorrelation;
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! hashcostestimate(PG_FUNCTION_ARGS)
  {
- 	PlannerInfo *root = (PlannerInfo *) PG_GETARG_POINTER(0);
- 	IndexPath  *path = (IndexPath *) PG_GETARG_POINTER(1);
- 	double		loop_count = PG_GETARG_FLOAT8(2);
- 	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(3);
- 	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(4);
- 	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(5);
- 	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(6);
  	List	   *qinfos;
  	GenericCosts costs;
  
--- 6736,6748 ----
  	*indexTotalCost = costs.indexTotalCost;
  	*indexSelectivity = costs.indexSelectivity;
  	*indexCorrelation = costs.indexCorrelation;
  }
  
! void
! hashcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
! 				 Cost *indexStartupCost, Cost *indexTotalCost,
! 				 Selectivity *indexSelectivity, double *indexCorrelation)
  {
  	List	   *qinfos;
  	GenericCosts costs;
  
*************** hashcostestimate(PG_FUNCTION_ARGS)
*** 6794,6813 ****
  	*indexTotalCost = costs.indexTotalCost;
  	*indexSelectivity = costs.indexSelectivity;
  	*indexCorrelation = costs.indexCorrelation;
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! gistcostestimate(PG_FUNCTION_ARGS)
  {
- 	PlannerInfo *root = (PlannerInfo *) PG_GETARG_POINTER(0);
- 	IndexPath  *path = (IndexPath *) PG_GETARG_POINTER(1);
- 	double		loop_count = PG_GETARG_FLOAT8(2);
- 	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(3);
- 	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(4);
- 	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(5);
- 	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(6);
  	IndexOptInfo *index = path->indexinfo;
  	List	   *qinfos;
  	GenericCosts costs;
--- 6782,6794 ----
  	*indexTotalCost = costs.indexTotalCost;
  	*indexSelectivity = costs.indexSelectivity;
  	*indexCorrelation = costs.indexCorrelation;
  }
  
! void
! gistcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
! 				 Cost *indexStartupCost, Cost *indexTotalCost,
! 				 Selectivity *indexSelectivity, double *indexCorrelation)
  {
  	IndexOptInfo *index = path->indexinfo;
  	List	   *qinfos;
  	GenericCosts costs;
*************** gistcostestimate(PG_FUNCTION_ARGS)
*** 6860,6879 ****
  	*indexTotalCost = costs.indexTotalCost;
  	*indexSelectivity = costs.indexSelectivity;
  	*indexCorrelation = costs.indexCorrelation;
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! spgcostestimate(PG_FUNCTION_ARGS)
  {
- 	PlannerInfo *root = (PlannerInfo *) PG_GETARG_POINTER(0);
- 	IndexPath  *path = (IndexPath *) PG_GETARG_POINTER(1);
- 	double		loop_count = PG_GETARG_FLOAT8(2);
- 	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(3);
- 	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(4);
- 	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(5);
- 	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(6);
  	IndexOptInfo *index = path->indexinfo;
  	List	   *qinfos;
  	GenericCosts costs;
--- 6841,6853 ----
  	*indexTotalCost = costs.indexTotalCost;
  	*indexSelectivity = costs.indexSelectivity;
  	*indexCorrelation = costs.indexCorrelation;
  }
  
! void
! spgcostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
! 				Cost *indexStartupCost, Cost *indexTotalCost,
! 				Selectivity *indexSelectivity, double *indexCorrelation)
  {
  	IndexOptInfo *index = path->indexinfo;
  	List	   *qinfos;
  	GenericCosts costs;
*************** spgcostestimate(PG_FUNCTION_ARGS)
*** 6926,6933 ****
  	*indexTotalCost = costs.indexTotalCost;
  	*indexSelectivity = costs.indexSelectivity;
  	*indexCorrelation = costs.indexCorrelation;
- 
- 	PG_RETURN_VOID();
  }
  
  
--- 6900,6905 ----
*************** gincost_scalararrayopexpr(PlannerInfo *r
*** 7222,7237 ****
  /*
   * GIN has search behavior completely different from other index types
   */
! Datum
! gincostestimate(PG_FUNCTION_ARGS)
  {
- 	PlannerInfo *root = (PlannerInfo *) PG_GETARG_POINTER(0);
- 	IndexPath  *path = (IndexPath *) PG_GETARG_POINTER(1);
- 	double		loop_count = PG_GETARG_FLOAT8(2);
- 	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(3);
- 	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(4);
- 	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(5);
- 	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(6);
  	IndexOptInfo *index = path->indexinfo;
  	List	   *indexQuals = path->indexquals;
  	List	   *indexOrderBys = path->indexorderbys;
--- 7194,7204 ----
  /*
   * GIN has search behavior completely different from other index types
   */
! void
! gincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
! 				Cost *indexStartupCost, Cost *indexTotalCost,
! 				Selectivity *indexSelectivity, double *indexCorrelation)
  {
  	IndexOptInfo *index = path->indexinfo;
  	List	   *indexQuals = path->indexquals;
  	List	   *indexOrderBys = path->indexorderbys;
*************** gincostestimate(PG_FUNCTION_ARGS)
*** 7382,7388 ****
  		*indexStartupCost = 0;
  		*indexTotalCost = 0;
  		*indexSelectivity = 0;
! 		PG_RETURN_VOID();
  	}
  
  	if (counts.haveFullScan || indexQuals == NIL)
--- 7349,7355 ----
  		*indexStartupCost = 0;
  		*indexTotalCost = 0;
  		*indexSelectivity = 0;
! 		return;
  	}
  
  	if (counts.haveFullScan || indexQuals == NIL)
*************** gincostestimate(PG_FUNCTION_ARGS)
*** 7504,7526 ****
  	*indexStartupCost += qual_arg_cost;
  	*indexTotalCost += qual_arg_cost;
  	*indexTotalCost += (numTuples * *indexSelectivity) * (cpu_index_tuple_cost + qual_op_cost);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   * BRIN has search behavior completely different from other index types
   */
! Datum
! brincostestimate(PG_FUNCTION_ARGS)
  {
- 	PlannerInfo *root = (PlannerInfo *) PG_GETARG_POINTER(0);
- 	IndexPath  *path = (IndexPath *) PG_GETARG_POINTER(1);
- 	double		loop_count = PG_GETARG_FLOAT8(2);
- 	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(3);
- 	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(4);
- 	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(5);
- 	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(6);
  	IndexOptInfo *index = path->indexinfo;
  	List	   *indexQuals = path->indexquals;
  	List	   *indexOrderBys = path->indexorderbys;
--- 7471,7486 ----
  	*indexStartupCost += qual_arg_cost;
  	*indexTotalCost += qual_arg_cost;
  	*indexTotalCost += (numTuples * *indexSelectivity) * (cpu_index_tuple_cost + qual_op_cost);
  }
  
  /*
   * BRIN has search behavior completely different from other index types
   */
! void
! brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
! 				 Cost *indexStartupCost, Cost *indexTotalCost,
! 				 Selectivity *indexSelectivity, double *indexCorrelation)
  {
  	IndexOptInfo *index = path->indexinfo;
  	List	   *indexQuals = path->indexquals;
  	List	   *indexOrderBys = path->indexorderbys;
*************** brincostestimate(PG_FUNCTION_ARGS)
*** 7573,7578 ****
  	*indexTotalCost += (numTuples * *indexSelectivity) * (cpu_index_tuple_cost + qual_op_cost);
  
  	/* XXX what about pages_per_range? */
- 
- 	PG_RETURN_VOID();
  }
--- 7533,7536 ----
